﻿using Microsoft.EntityFrameworkCore.Query.ExpressionTranslators;
using Microsoft.EntityFrameworkCore.Query.ExpressionTranslators.Internal;
using Microsoft.Extensions.Logging;

namespace Luticate2.Utils.DataAccess.Npgsql
{
    public class NpgsqlCompositeMethodCallTranslatorLuticate : NpgsqlCompositeMethodCallTranslator
    {
        private static readonly IMethodCallTranslator[] _methodCallTranslators2 =
        {
            new NpgsqlIntToStringTranslator(),
            new NpgsqlStoredProcTranslator()
        };

        public NpgsqlCompositeMethodCallTranslatorLuticate(ILogger<NpgsqlCompositeMethodCallTranslator> logger) : base(logger)
        {
            AddTranslators(_methodCallTranslators2);
        }
    }
}