﻿using System.ComponentModel.DataAnnotations;
using Luticate2.Utils.Dbo.Filter;
using Luticate2.Utils.Dbo.OrderBy;

namespace Luticate2.Utils.Dbo.PaginatedRequest
{
    public class LuPaginatedRequestDbo<TFilterDbo> where TFilterDbo : LuFilterDbo
    {
        [Required]
        public TFilterDbo Filter { get; set; }

        [Required]
        public LuOrderByDbo OrderBy { get; set; }

        [Required]
        [Range(0, int.MaxValue)]
        public int Page { get; set; }

        [Required]
        [Range(1, int.MaxValue)]
        public int PerPage { get; set; }
    }

    public class LuPaginatedRequestDbo : LuPaginatedRequestDbo<LuFilterDbo>
    {
    }
}