﻿using System;
using Luticate2.Utils.Dbo.Basic;
using Luticate2.Utils.Dbo.PaginatedRequest;
using Luticate2.Utils.Dbo.Result;

namespace Luticate2.Utils.Interfaces
{
    public interface ILuCrudInterface<TDboCreate, TDboRead, TDboUpdate, TId>
        where TDboCreate : class
        where TDboRead : class
        where TDboUpdate : class
    {
        TId GetDboId(TDboRead obj);

        LuResult<T> Add<T>(TDboCreate obj, Func<TDboRead, T> returnFunc);

        LuResult<TDboRead> GetSingleById(TId id);

        LuResult<LuPaginatedDbo<TDboRead>> GetMultiple(LuPaginatedRequestDbo request);

        LuResult<T> EditSingleById<T>(TId id, TDboUpdate update, Func<TDboRead, T> returnFunc);

        LuResult<T> DeleteSingleById<T>(TId id, Func<TDboRead, T> returnFunc);
    }
}